package com.yc.ship.module.trade.service.contract;


import com.yc.ship.framework.common.pojo.CommonResult;
import com.yc.ship.framework.common.pojo.PageResult;
import com.yc.ship.module.trade.api.contract.dto.ContractApplyReqDTO;
import com.yc.ship.module.trade.api.contract.dto.QueryContractRespDTO;
import com.yc.ship.module.trade.controller.admin.contract.vo.ContractPageReqVO;
import com.yc.ship.module.trade.controller.admin.contract.vo.ContractReqVO;
import com.yc.ship.module.trade.controller.admin.contract.vo.ContractSaveReqVO;
import com.yc.ship.module.trade.dal.dataobject.contract.ContractDO;

import javax.validation.Valid;
import java.util.List;

/**
 * 合同 Service 接口
 *
 * @author 管理员
 */
public interface ContractService {

    /**
     * 创建合同
     *
     * @param requestDTO 创建信息
     * @return 编号
     */
    CommonResult<?> applyContract(ContractApplyReqDTO requestDTO );

    /**
     * 更新合同
     *
     * @param updateReqVO 更新信息
     */
    void updateContract(@Valid ContractSaveReqVO updateReqVO);

    /**
     * 删除合同
     *
     * @param id 编号
     */
    void deleteContract(Long id);

    /**
     * 获得合同
     *
     * @param id 编号
     * @return 合同
     */
    ContractDO getContract(Long id);

    /**
     * 获得合同分页
     *
     * @param pageReqVO 分页查询
     * @return 合同分页
     */
    PageResult<ContractDO> getContractPage(ContractPageReqVO pageReqVO);

    /**
     * 合同作废
     * @param orderId
     * @return
     */
    Boolean cancel(Long orderId);

    /**
     * 发送合同短信

     * @return
     */
     boolean sendContractSms(ContractReqVO reqVO);

    /**
     * 查询合同信息
     * @param contractId
     * @return
     */
    QueryContractRespDTO queryContract(Long contractId);

    /**
     * 查询合同状态
     * @param contractNo
     */
    Integer queryContractStatus(Long contractNo);

    void updateContractStatus(Long contractId,Integer status);

    /**
     * 合同回调
     * @param body
     * @return
     */
    String contractCallBackNotice(String body);

    List<ContractDO> getContractByOrder(Long orderId);

}